$( document ).ready( function() {

    var app = new AppController();

    $( window ).on( "popstate", false );
    $( window ).on( "popstate", app.loadLastSection );

    $( window ).on( "scroll", app.scrollApp );

    $( document ).on( "tap", "button[name='menu']", app.openMenu );
    $( document ).on( "tap", "button[name='scroll']", app.setScroll );
    $( document ).on( "tap", "button[name='image']", app.selectImage );
    $( document ).on( "tap", "a[data-section]", app.setSection );
    $( document ).on( "tap", "a[data-link]", app.openLink );
    $( document ).on( "tap", "a[data-action]", app.openAction );
    $( document ).on( "tap", "a[data-track]", app.trackClick );
    $( document ).on( "tap", "a[data-marker]", app.setMarker );
    $( document ).on( "tap", "a[data-filter='productfilter']", app.toggleProductFilter );
    $( document ).on( "tap", "a[data-filter='mapfilter']", app.toggleMapFilter );
    $( document ).on( "tap", "a[data-filter='chatfilter']", app.toggleChatFilter );
    $( document ).on( "tap", "a[data-guest]", app.unsetGuest );

    $( document ).on( "tap", "img.maximize", false );
    $( document ).on( "tap", "img.maximize, div#maximize", app.maximizeImage );

    $( document ).on( "taphold", "form#profile a[data-profile]", app.focusProfile );
    $( document ).on( "taphold", "form#budgetlist a[data-budget]", app.focusBudget );

    $( document ).on( "submit", "form", false );
    $( document ).on( "submit", "form#mapfilter", app.setLocation );
    $( document ).on( "submit", "form#sendchat", app.sendChat );
    $( document ).on( "submit", "form#guestlist", app.setGuest );
    $( document ).on( "submit", "form#loginuser", app.loginUser );
    $( document ).on( "submit", "form#restoreuser", app.restoreUser );
    $( document ).on( "submit", "form#registeruser", app.registerUser );

    $( document ).on( "change", "form#productfilter select", app.initializeProducts );
    $( document ).on( "change", "form#productfilter div[data-role='rangeslider']", app.updatePriceFilter );
    $( document ).on( "change", "form#chatfilter input[name='channel']", app.setChannel );
    $( document ).on( "change", "form#sendchat input[name='image']", app.loadImage );
    $( document ).on( "change", "form#todolist input[data-todo]", app.setTodo );

    $( document ).on( "focusin", "form#profile input[name^='date']", app.focusDate );
    $( document ).on( "focusin", "form#budgetlist input", app.focusBudget );

    $( document ).on( "focusout", "form#profile input[name^='date']", app.setDate );
    $( document ).on( "focusout", "form#budgetlist input", app.setBudget );

    $( document ).on( "sortupdate", "ul#guests", app.sortGuests );

    $( document ).on( "slidestop", "form#productfilter div[data-role='rangeslider']", app.initializeProducts );

    $( document ).on( "keyup", "form#loginuser input, form#restoreuser input, form#registeruser input", function( event ) {
        if (event.keyCode != 13) {
            app.resetErrors();
        }
    });

});